# Building

## Dependencies

 - C++ compiler supporting C++17 and OpenMP, e.g. [GCC](https://gcc.gnu.org/) 8 and later.
 - [GNU Make](https://www.gnu.org/software/make/).
 - [Boost](http://www.boost.org/) 1.58 or higher with the following libraries: program options, filesystem and iostreams.
 - [zlib](http://www.zlib.net/).
 - [CMake](https://cmake.org/) 3.11 or higher.
 - JDK 12 or higher, either from [Oracle](http://www.oracle.com/technetwork/java/javase/downloads/index.html) or [OpenJDK](http://openjdk.java.net/projects/jdk/12/).

**Ubuntu 19.04**

On Ubuntu 19.04, all dependencies can be installed as follows:
```
sudo apt install g++ cmake make libboost-dev libboost-program-options-dev libboost-filesystem-dev libboost-iostreams-dev zlib1g-dev openjdk-12-jdk
```

**Arch Linux**

On Arch Linux, all dependencies can be installed as follows:
```
sudo pacman -S gcc cmake make boost boost-libs zlib jdk-openjdk
sudo archlinux-java set java-12-openjdk
```

## Compilation

If the repository has been cloned with git, first the submodules have to be initialized.
If Strix has been obtained as a release zip file, this step can be skipped.
```
git submodule init
git submodule update
```

The compilation process can be started by:
```
make
```

After compilation, the folder `bin` will be created and should contain the executable `strix` and the library `owl.jar`.
To use strix, the executable `strix` has to be invoked, but the `owl.jar` library has to remain in the same directory,
or the directory containing it has to be given with the `--owl-jar-dir` option.
