# Owl

A Java tool collection and library  for **O**mega-**w**ords, ω-automata and **L**inear Temporal Logic (LTL). Batteries included.

Major functionality (e.g., translations, simplifiers) is available through command-line tools and for fine-grained access there exists a Java and C++ API. Details on how to use Owl are given in the [usage instructions](doc/USAGE.md) and [build instructions](doc/BUILDING.md). Owl requires at least [Java 11](http://jdk.java.net/11/) or newer.

Note that the distribution only contains compiled code and the necessary sources to build Owl can be found in the [repository](https://gitlab.lrz.de/i7/owl).

If you want to contribute to Owl, read the [contribution guidelines](CONTRIBUTING.md) which are mandatory if you want your changes to be merged into the main branch.
Read the javadoc of the respective packages of the infrastructure you plan to use, e.g., `owl.automaton`. It contains links to the relevant classes and typical use cases.

For further information see the official [website](https://owl.model.in.tum.de/).

## Publications

Please see the [citing section of the official website for an updated list](https://owl.model.in.tum.de/#citing).
