#include "LTLParser.h"

#include <iostream>
#include <sstream>

namespace ltl {

LTLParser::LTLParser(const owl::OwlThread& owl, std::vector<std::string>& inputs, std::vector<std::string>& outputs) :
    Parser(owl),
    inputs(inputs),
    outputs(outputs)
{ }

LTLParser::~LTLParser() { }

Specification LTLParser::parse_string_with_factory(
        owl::FormulaFactory& factory,
        const std::string& text
) const {
    // Create list of variables for parser
    std::vector<std::string> variables;
    variables.insert(variables.end(), inputs.cbegin(), inputs.cend());
    variables.insert(variables.end(), outputs.cbegin(), outputs.cend());

    // Parse with provided variables
    Specification spec = factory.parse(text, variables);

    // Return specification with input and output variables
    spec.inputs.insert(spec.inputs.end(), inputs.cbegin(), inputs.cend());
    spec.outputs.insert(spec.outputs.end(), outputs.cbegin(), outputs.cend());
    return spec;
}

}
